/* -*- buffer-read-only: t -*- vi: set ro:
#line 431
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 431
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_DB
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_db.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mu_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			env_throw(env, mf_dbfailure,  "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 37
;

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = (void*) keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_fetch(&db, key, &contents) == 0;
	debug2(10, "Looking up %s: %s", keystr, rc ? "true" : "false");
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MU_DATUM_PTR(contents))[MU_DATUM_SIZE(contents)-1]) {
			size_t off;
			size_t len = MU_DATUM_SIZE(contents);
			char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
			memcpy(s, MU_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) off);
		} else
			pushs(env, MU_DATUM_PTR(contents));
	}
	mu_dbm_datum_free(&contents);
	mu_dbm_close(&db);
	return rc;
}

void
#line 70
bi_dbmap(eval_environ_t env)
#line 70

#line 70 "bi_db.m4"
{
#line 70
	
#line 70
char * dbname = (char *) get_string_arg(env, 2);
#line 70
        char * key = (char *) get_string_arg(env, 1);
#line 70
        long  null = (long ) get_numeric_arg(env, 0);
#line 70
        
#line 70
        adjust_stack(env, 3);
#line 70

#line 70
	if (prog_trace_option & BUILTIN_MASK_db)
#line 70
		prog_trace(env, "dbmap %s %s %lu",dbname, key, null);;
#line 70

{
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | 
                        ((null) ? LOOKUP_NULL_BYTE : 0));
}
}

#line 79
void
#line 79
bi_dbget(eval_environ_t env)
#line 79

#line 79 "bi_db.m4"
{
#line 79
	
#line 79
char * dbname = (char *) get_string_arg(env, 3);
#line 79
        char * key = (char *) get_string_arg(env, 2);
#line 79
        char * defval = (char *) get_string_arg(env, 1);
#line 79
        long  null = (long ) get_numeric_arg(env, 0);
#line 79
        
#line 79
        adjust_stack(env, 4);
#line 79

#line 79
	if (prog_trace_option & BUILTIN_MASK_db)
#line 79
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, defval, null);;
#line 79

{
	dbmap_lookup(env, dbname, key, 
                     defval, 
                     ((null) ? LOOKUP_NULL_BYTE : 0));
}
}

#line 88
void
#line 88
bi_dbput(eval_environ_t env)
#line 88

#line 88 "bi_db.m4"
{
#line 88
	
#line 88
char * dbname = (char *) get_string_arg(env, 3);
#line 88
        char * keystr = (char *) get_string_arg(env, 2);
#line 88
        char * value = (char *) get_string_arg(env, 1);
#line 88
        long  null = (long ) get_numeric_arg(env, 0);
#line 88
        
#line 88
        adjust_stack(env, 4);
#line 88

#line 88
	if (prog_trace_option & BUILTIN_MASK_db)
#line 88
		prog_trace(env, "dbput %s %s %s %lu",dbname, keystr, value, null);;
#line 88

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw(env, mf_dbfailure,                                             "dbput: " "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 99
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if ((null))
		MU_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(contents) = value;
	MU_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mu_dbm_insert(&db, key, contents, 1);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 118
			env_throw(env, mf_dbfailure,                                             "dbput: " "failed to insert data to %s: %s %s: %s",dbname,keystr,value,mu_dbm_strerror());
#line 118
;
#line 118
;
}
}

void
#line 122
bi_dbdel(eval_environ_t env)
#line 122

#line 122 "bi_db.m4"
{
#line 122
	
#line 122
char * dbname = (char *) get_string_arg(env, 2);
#line 122
        char * keystr = (char *) get_string_arg(env, 1);
#line 122
        long  null = (long ) get_numeric_arg(env, 0);
#line 122
        
#line 122
        adjust_stack(env, 3);
#line 122

#line 122
	if (prog_trace_option & BUILTIN_MASK_db)
#line 122
		prog_trace(env, "dbdel %s %s %lu",dbname, keystr, null);;
#line 122

{
	DBM_FILE db;
	DBM_DATUM key;
	int rc;	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw(env, mf_dbfailure,                                             "dbdel: " "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 131
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if ((null))
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_delete(&db, key);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 144
			env_throw(env, mf_dbfailure,                                             "dbdel: " "failed to delete data `%s' from `%s': %s",key,dbname,mu_dbm_strerror());
#line 144
;
#line 144
;
}
}


static void
greylist_print_item(const char *key, size_t size, const void *content)
{
	time_t timestamp = *(time_t*) content;
	size--; /* Size includes the trailing nul */
	printf("%*.*s ", size, size, key);
	format_time_str(stdout, timestamp);
	putchar('\n');
}

static int
greylist_expire_item(const void *content)
{
	time_t timestamp = *(time_t*) content;
	return greylist_format->expire_interval &&
		time(NULL) - timestamp > greylist_format->expire_interval;
}


static struct db_format greylist_format_struct = {
	"greylist",
	DEFAULT_GREYLIST_DATABASE,
	DEFAULT_EXPIRE_INTERVAL,
	greylist_print_item,
	greylist_expire_item
};

struct db_format *greylist_format = &greylist_format_struct;

static size_t greylist_seconds_left_loc
#line 178 "bi_db.m4"
;

#line 184
/* greylist(key, interval)
#line 184

#line 184
   Returns true if the key is greylisted, false if it's OK to
#line 184
   deliver mail.
#line 184
 */
void
#line 185
bi_greylist(eval_environ_t env)
#line 185

#line 185 "bi_db.m4"
{
#line 185
	
#line 185
char * email = (char *) get_string_arg(env, 1);
#line 185
        long  interval = (long ) get_numeric_arg(env, 0);
#line 185
        
#line 185
        adjust_stack(env, 2);
#line 185

#line 185
	if (prog_trace_option & BUILTIN_MASK_db)
#line 185
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 185

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	int readonly;
	time_t now;

	if (prog_trace_option)
		prog_trace(env, "GREYLIST \"%s\" %s %ld %ld", greylist_format->dbname, email, interval);

	rc = mu_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
			env_throw(env, mf_dbfailure,                                             "greylist: " "mu_dbm_open(%s) failed: %s",greylist_format->dbname,mu_dbm_strerror());
#line 200
;
#line 200
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = email;
	MU_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mu_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MU_DATUM_SIZE(contents) == sizeof timestamp))
#line 214
			env_throw(env, mf_dbfailure,                                             "greylist: " "greylist database %s has wrong data size",greylist_format->dbname);
#line 214
;
#line 214
;
		
		timestamp = *(time_t*) MU_DATUM_PTR(contents);
		diff = now - timestamp;
	
		__DBG(20) {
			char timebuf[32];
			debug_log("%s entered greylist database on %s, "
				  "%ld seconds ago",
				  email,
				  mailfromd_timestr(timestamp, timebuf,
						    sizeof timebuf),
				  (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			debug2(20, "%s still greylisted (for %lu sec.)",
			       email,
			       (unsigned long) diff);
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			debug1(20, "greylist record for %s expired",
			       email);
			if (!readonly) {
				memcpy(MU_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mu_dbm_insert(&db, key, contents, 1))
					mu_error("Cannot insert datum `%s' in "
						 "greylist database %s: %s",
			                         key,
						 greylist_format->dbname,
	                                         mu_dbm_strerror());
			} else
				debug(20, "database opened in readonly mode: "
				      "not updating");
			rc = 1;
		} else {
			debug1(20, "%s finished greylisting period",
			       email);
			rc = 0;
		}
		mu_dbm_datum_free(&contents);
	} else if (!readonly) {
		debug1(20, "greylisting %s", email);
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MU_DATUM_PTR(contents) = (void*)&now;
		MU_DATUM_SIZE(contents) = sizeof now;
		if (mu_dbm_insert(&db, key, contents, 1))
			mu_error("Cannot insert datum `%s' in greylist "
				 "database %s: %s",
		                 key,
				 greylist_format->dbname,
	                         mu_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mu_dbm_close(&db);

	do {
#line 277
push(env, (STKVAL) (rc));
#line 277
return;
#line 277
} while (0);
}
}

void
#line 281
bi_db_name(eval_environ_t env)
#line 281

#line 281 "bi_db.m4"
{
#line 281
	
#line 281
char * fmtid = (char *) get_string_arg(env, 0);
#line 281
        
#line 281
        adjust_stack(env, 1);
#line 281

#line 281
	if (prog_trace_option & BUILTIN_MASK_db)
#line 281
		prog_trace(env, "db_name %s",fmtid);;
#line 281

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 286
			env_throw(env, mf_not_found,                                             "db_name: " "no such db : %s",fmtid);
#line 286
;
#line 286
;
	do {pushs(env, fmt->dbname);
#line 287
return;
#line 287
} while (0);
}
}

void
#line 291
bi_db_expire_interval(eval_environ_t env)
#line 291

#line 291 "bi_db.m4"
{
#line 291
	
#line 291
char * fmtid = (char *) get_string_arg(env, 0);
#line 291
        
#line 291
        adjust_stack(env, 1);
#line 291

#line 291
	if (prog_trace_option & BUILTIN_MASK_db)
#line 291
		prog_trace(env, "db_expire_interval %s",fmtid);;
#line 291

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 296
			env_throw(env, mf_not_found,                                             "db_expire_interval: " "no such db : %s",fmtid);
#line 296
;
#line 296
;
	do {
#line 297
push(env, (STKVAL) (fmt->expire_interval));
#line 297
return;
#line 297
} while (0);
}
}


#line 301
void
#line 301
db_init_builtin()
#line 301
{
#line 301
	#line 70 "bi_db.m4"
va_builtin_install_ex("dbmap", bi_dbmap, 0, 0, dtype_number,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 79 "bi_db.m4"
va_builtin_install_ex("dbget", bi_dbget, 0, 0, dtype_string,  4, 2,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 88 "bi_db.m4"
va_builtin_install_ex("dbput", bi_dbput, 0, 0, dtype_unspecified,  4, 1,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 122 "bi_db.m4"
va_builtin_install_ex("dbdel", bi_dbdel, 0, 0, dtype_unspecified,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 178 "bi_db.m4"
	greylist_seconds_left_loc = builtin_variable_install("greylist_seconds_left", dtype_number, VAR_VOLATILE)->off;
#line 185 "bi_db.m4"
va_builtin_install_ex("greylist", bi_greylist, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_number);
#line 281 "bi_db.m4"
va_builtin_install_ex("db_name", bi_db_name, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 291 "bi_db.m4"
va_builtin_install_ex("db_expire_interval", bi_db_expire_interval, 0, 0, dtype_number,  1, 0,  dtype_string);

#line 301 "bi_db.m4"
		
#line 301
}

#line 0

#line 0

